var MISSING = "missing";
var EMPTY = "";
var errMsg = "";
var type = "";
var intRegex = /^\d+$/;

var smashdb = null;
webUrl ="http://smashfit4kids.com/test.php"; //"http://man302.net76.net/test1.php"; //"http://smashfit4kids.com/test.php";
$.support.cors = true;

function Registration(uName, pass, age, pName, sub, state, country, pin, email, callback){ 
	$.post(webUrl, { type: "Registration", uname: uName, pass: pass, age: age, pname: pName, sub: sub, state: state, country: country, pin: pin, email: email},
		function(data) {
			callback(data);
   }).error(function() { callback("error"); });

}


function updateErrMsg(t) {
	errMsg += "<li>" + t + "</li>";
}

function checkLength(o, min, max, msg) {
	if (o.val().trim().length > max || o.val().trim().length < min) {
		o.addClass("error");
		updateErrMsg(msg);
		return false;
	} else {
		o.removeClass("error");
		return true;
	}
}

function checkEmpty(o, t, msg) {
	if(t == "r"){
		if (o.val() == 0) {
			o.addClass("error");
			updateErrMsg(msg);
			return false;
		} else {
			o.removeClass("error");
			return true;
		}
	}
	else{
		if (o.val().trim().length == 0) {
			o.addClass("error");
			updateErrMsg(msg);
			return false;
		} else {
			o.removeClass("error");
			return true;
		}
	}

}

function checkRegexp(o, regexp, n) {
	if (!(regexp.test(o.val()))) {
		o.addClass("error");
		updateErrMsg(n);
		return false;
	} else {
		o.removeClass("error");
		return true;
    }
}

function ShowDialog(containerId, msg, msgType){
	type = msgType;
	$("#" + containerId).simpledialog({
	'mode' : 'blank',
		'prompt' : false,
	   'forceInput': false,
		'useModal': true,
		'fullHTML':msg,
		'buttons' : {  
			"OK": {  
				click: function () {
					if(type == "regadd"){
						ResetRegistration();
						window.location.href = "index.html";
					}
				}  
			} 
		},
		"pickPageTheme": "a",
		"pickPageButtonTheme":"a"
	})
}

function ResetRegistration(){
    $("#txtUserName", "#registration").val("");
    $("#txtPassword", "#registration").val("");
    $("#txtAge", "#registration").val(0).slider("refresh");
    $("#txtParentName", "#registration").val("");
    $("#txtSuburb", "#registration").val("");
    $("#txtState", "#registration").val("");
    $("#ddlCountry option[value='']", "#registration").attr("selected", "selected");
    $('#ddlCountry', "#registration").selectmenu('refresh', true); 
    $("#txtPin", "#registration").val("");
    $("#txtEmailAddress", "#registration").val("");
    $("#txtTC", "#registration").attr("checked",false).checkboxradio("refresh");
    $("#regInputError").html("").hide();
}

function ValidateRegistration(){

	errMsg = EMPTY;
	$("#regInputError").html("").hide();
	var username = $("#txtUserName", "#registration"),
		password = $("#txtPassword", "#registration"),
		age = $("#txtAge", "#registration"),
		parentname = $("#txtParentName", "#registration"),
		suburb = $("#txtSuburb", "#registration"),
		state = $("#txtState", "#registration"),
		country = $("#ddlCountry", "#registration"),
		pin = $("#txtPin", "#registration"),
		email = $("#txtEmailAddress", "#registration"),
		tandc = $("#txtTC", "#registration");
		bValid = true;
		
	if(!checkLength(username, 3, 16, "Username has to contain 3-15 characters.")){
		bValid = false;
	}
	if(!checkLength(password, 6, 16, "Password has to contain atleast 6 characters.")){
		bValid = false;
	}
	if(!checkEmpty(age, "r", "Age cannot be zero.")){
		bValid = false;
	}
	if(bValid && age.val() < 14){
		if(!checkEmpty(parentname, EMPTY, "Parent/Guardian name cannot be empty.")){
			bValid = false;
		}
	}
	if(!checkEmpty(suburb, EMPTY, "Suburb cannot be empty.")){
	    bValid = false;
	}
	if(!checkEmpty(state, EMPTY, "State cannot be empty.")){
		bValid = false;
	}
	if(!checkEmpty(country, EMPTY, "Country name cannot be empty.")){
		bValid = false;
	}
	if(!checkEmpty(pin, EMPTY, "Post/zip cannot be empty.")){
		bValid = false;
	}
	//else if(!checkRegexp(pin, intRegex, "Enter valid pin.")){
	 //   bValid = false;	    
	//}
	if(!checkEmpty(email, EMPTY, "Email address cannot be empty.")){
		bValid = false;
	}
	else if(!checkRegexp(email, /^\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$/, "Enter valid email address.")){
		bValid = false;
	}
	if(!tandc.is(":checked")){
		updateErrMsg("You have not agreed to our terms and conditions");
		bValid = false;
	}
	if(bValid && errMsg === EMPTY){
		//Register
		
		Registration(username.val(), password.val(), age.val(), parentname.val(), suburb.val(), state.val(), country.val(), pin.val(), email.val(), function(data){
			if(data == "true"){
				ShowDialog("popupRegistration", "Thank you for registering. Your account has been created successfully. You may now log in with your username and password", "regadd");
						ResetRegistration();
			}
			else if(data == "false"){
				ShowDialog("popupRegistration", "Failed to create your account.Please try again!", "err");
			}
			else{
				ShowDialog("popupRegistration", data, "err");
				//ResetRegistration();
				//window.location.href = "index.html";
			}
		});
	
		
	}
	else{
		
		//ErrMsg
		$("#regInputError").html(errMsg);
		$("#regInputError").show();
		$("html, body").animate({scrollTop:$("#regInputError").offset().top}, "slow");
	}
}

function RedirectLogin(){
	ResetRegistration();
	window.location.href = "index.html";
}

$(document).on("pageinit","#registration",function(){ // the .on() method does require jQuery 1.7 + but this will allow you to have the contained code only run when the #splash page is initialized.
    $.support.cors = true;
    $.mobile.allowCrossDomainPages=true;
	$("#regInputError").hide();
	$(".ui-btn-text a", "#divTC").click(function(event) {
		var checked = $("#txtTC[type='checkbox']").is(":checked");
		var $this = $(this);
			  
			$.mobile.changePage("#tc", {
				transition : "pop",
				role       : "dialog"
			});
		stateOfCheckbox(checked);
	});

	function stateOfCheckbox(checked) {
		$("#registration").live( "pagebeforeshow", function(event){
			$("#txtTC[type='checkbox']").attr("checked",checked).checkboxradio("refresh");
		});
	}
});

